!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine AdvectVelX
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: advectvelx.f90,v 1.4 2005/02/02 10:07:26 odakker Exp $
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview
!
! X αưΰή׻. ư 2 Ȥ. 
! AdvX = u \DP{u}{x} + w \DP{w}{x}
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!
                                                                 !=end

subroutine AdvectVelX(fs_VelX_n, sf_VelZ_n, fs_AdvX_n)
                                                                 !=begin
  !== Dependency
  use dc_trace,      only: BeginSub, EndSub 
  use gridset,       only: DimXMin, DimXMax, DimZMin, DimZMax
  use average,       only: fs_avr_ss, ss_avr_fs, fs_avr_ff, ff_avr_sf
  use differentiate_center2, only: ss_dx_fs, ff_dz_fs
                                                                 !=end
  !--- ۤηػ
  implicit none
                                                                 !=begin  
  !== input
  real(8), intent(in)     :: fs_VelX_n(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)     :: sf_VelZ_n(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end
                                                                 !=begin
  !== output
  real(8), intent(out)    :: fs_AdvX_n(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end

  call BeginSub("AdvectVelX", &
&               fmt="%c",       &
&               c1="Calculate advection term for VelX (fs_AdvX).")

  !--- ή (X)
  fs_AdvX_n = &
       &    fs_avr_ss( ss_avr_fs( fs_VelX_n ) * ss_dx_fs( fs_VelX_n ) ) &
       & +  fs_avr_ff( ff_avr_sf( sf_VelZ_n ) * ff_dz_fs( fs_VelX_n ) )

  call EndSub("AdvectVelX")
  
end subroutine AdvectVelX
